# -*- coding: utf-8 -*-

from resources.lib.modules import client
from resources.lib.modules import client_utils
from resources.lib.modules import cleantitle
from resources.lib.modules import scrape_sources
#from resources.lib.modules import log_utils


class source:
    def __init__(self):
        self.results = []
        self.domains = ['pinoy-hd.asia', 'pinoy-hd.xyz']
        self.base_link = 'https://pinoy-hd.asia'
        self.search_link = '/search/?q=%s'


    def movie(self, imdb, title, localtitle, aliases, year):
        try:
            search_url = self.base_link + self.search_link % cleantitle.get_plus(title)
            r = client.request(search_url)
            r = client_utils.parseDOM(r, 'div', attrs={'class': 'eTitle'})
            r = [(client_utils.parseDOM(i, 'a', ret='href'), client_utils.parseDOM(i, 'a')) for i in r]
            r = [(i[0][0], i[1][0]) for i in r if len(i[0]) > 0 and len(i[1]) > 0]
            url = [i[0] for i in r if cleantitle.match_alias(client_utils.remove_codes(i[1]), aliases)][0]
            url = self.base_link + url
            return url
        except Exception:
            #log_utils.log('movie', 1)
            return


    def sources(self, url, hostDict):
        try:
            if url == None:
                return self.results
            #log_utils.log('Scraper pinoy-hd starting url: \n' + repr(url))
            r = client.request(url)
            r = client_utils.parseDOM(r, 'div', attrs={'class': 'tabcontent'})
            links = client_utils.parseDOM(r, 'iframe', ret='src')
            for link in links:
                #log_utils.log('Scraper pinoy-hd source link: \n' + repr(link))
                for source in scrape_sources.process(hostDict, link):
                    self.results.append(source)
            return self.results
        except Exception:
            #log_utils.log('sources', 1)
            return self.results


    def resolve(self, url):
        return url


